(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2012 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)

(*
  Time-stamp: <Last modified on 2013-03-04 22:44:15 CET by Kim Nguyen>
*)

exception InfiniteSet
module type S =
sig
  include Hcons.S
  include Common_sig.Set with type t := t
  type set
  val any : t
  val is_any : t -> bool
  val is_finite : t -> bool
  val kind : t -> [ `Finite | `Cofinite ]
  val complement : t -> t
  val kind_split : t list -> t * t
  val positive : t -> set
  val negative : t -> set
  val inj_positive : set -> t
  val inj_negative : set -> t
end
