(***********************************************************************)
(*                                                                     *)
(*                               TAToo                                 *)
(*                                                                     *)
(*                     Kim Nguyen, LRI UMR8623                         *)
(*                   Université Paris-Sud & CNRS                       *)
(*                                                                     *)
(*  Copyright 2010-2012 Université Paris-Sud and Centre National de la *)
(*  Recherche Scientifique. All rights reserved.  This file is         *)
(*  distributed under the terms of the GNU Lesser General Public       *)
(*  License, with the special exception on linking described in file   *)
(*  ../LICENSE.                                                        *)
(*                                                                     *)
(***********************************************************************)

(*
  Time-stamp: <Last modified on 2013-04-04 18:45:59 CEST by Kim Nguyen>
*)

open Format

type t = int
let make =
  let id = ref ~-1 in
    fun () -> incr id; !id

let compare = (-)

let equal = (==)

external hash : t -> int =  "%identity"

let print fmt x = fprintf fmt "q%a" Pretty.pp_subscript x

let dump fmt x = print fmt x

let check x =
  if x < 0 then failwith (Printf.sprintf "State: Assertion %i < 0 failed" x)

let dummy = max_int
